@import "../init";

%icon-list {
  --icon-size: var(--icon-size-md);
  --icon-vertical-offset: -2px;
  --icon-gap: var(--bs-spacer-1);
  --item-gap: var(--bs-spacer-3);
  margin-left: 0;
  padding-left: 0;

  li {
    list-style: none outside none;
    margin-bottom: 0.75em;
    padding-left: calc(var(--icon-size) + var(--icon-gap));
    position: relative;
    line-height: var(--bs-line-height-sm);
    // Prevent larger icons from overlapping content
    min-height: var(--icon-size);

    &:not(:last-child) {
      margin-bottom: var(--item-gap);
    }

    &::before {
      left: 0;
      font-size: var(--icon-size);
      line-height: var(--icon-size);
      padding: 2px;
      position: absolute;
      top: 0;
      transform: translateY(var(--icon-vertical-offset));
    }

    ul {
      margin-top: var(--bs-spacer-1);
      margin-left: 0;
    }
  }
}

.styled-list {
  padding-left: 0;
  &:last-child {
    margin-bottom: 0;
  }

  &--comma {
    padding: 0;
    margin-left: 0;

    li {
      list-style: none;
      display: inline;

      * {
        display: inline !important;
      }

      &:not(:last-child)::after {
        content: ", ";
        margin-left: -0.2em; // bugfix - for some reason theres a gab between text and comma
      }
    }
  }

  &--square {
    list-style: square;
  }

  &--checklist {
    @extend %icon-list;
    li {
      &::before {
        @include get-ico-only(
          var(--icon-theme-check),
          $iconfont-family: var(--basics-frontend-iconfont-family)
        );
      }
    }
  }

  &--arrow {
    @extend %icon-list;
    li {
      &::before {
        @include get-ico-only(
          var(--icon-theme-next-arrow),
          $iconfont-family: var(--basics-frontend-iconfont-family)
        );
      }
    }
  }

  &--data-grid {
    // Creates a label | data grid, with equal wide labels
    --label-col-width: 35%;
    --spacer-between-v: var(--bs-spacer-1);
    --spacer-between-h: var(--bs-spacer-2);
    --cell-padding-v: 0px;
    --cell-padding-h: 0px;
    container-type: inline-size;
    display: flex;
    gap: var(--spacer-between-v) var(--spacer-between-h);
    flex-flow: row wrap;
    margin-left: 0;
    hyphens: auto;
    line-height: var(--bs-line-height-sm);

    // Fix inline label style conflict
    .field__item {
      display: block;
    }
    > * {
      // Using this selector since for eg. views-fields are entirely different named and structured as regular fields - for whatever reason.
      flex: 0 0 auto;
      width: 100%;
      list-style: none;
      padding: 0.15em 0.35em;
      margin: 0 !important;
      padding: var(--cell-padding-v) var(--cell-padding-h) !important;
      transition-duration: 150ms;
      transition-delay: 50ms;
      border-bottom: 1px solid $white;
      transition-property: border-color, background-color, color;
      &:nth-child(2n-1) {
        background: var(--bs-gray-light);
        font-weight: var(--bs-font-weight-bold);

        @container (min-width: 25em) {
          width: calc(
            var(--label-col-width) - (var(--spacer-between-h) * 0.5) -
              (var(--cell-padding-h) * 2)
          );
        }
      }
      &:nth-child(2n) {
        @container (min-width: 25em) {
          width: calc(
            100% - var(--label-col-width) - (var(--spacer-between-h) * 0.5) -
              (var(--cell-padding-h) * 2)
          );
        }
      }
    }
  }
}
